package com.test.de.server;


import javax.enterprise.context.ApplicationScoped;
import javax.inject.Inject;
import javax.persistence.EntityManager;
import javax.persistence.NoResultException;
import javax.persistence.PersistenceContext;
import javax.transaction.HeuristicMixedException;
import javax.transaction.HeuristicRollbackException;
import javax.transaction.NotSupportedException;
import javax.transaction.RollbackException;
import javax.transaction.SystemException;
import javax.transaction.UserTransaction;

import com.test.de.shared.Address;

/**
 * Facade to fetch related data
 */
@ApplicationScoped
public class DataFacade {

	@PersistenceContext
	private EntityManager entityManager;

	@Inject
	private UserTransaction userTransaction;
	
	
	public DataFacade(){
	}


	public Address getAddressForAddressId(long addressId) throws NotSupportedException, SystemException, SecurityException, IllegalStateException, RollbackException, HeuristicMixedException, HeuristicRollbackException{
		
			try {
				userTransaction.begin();
				return entityManager.createQuery("from Address where id = " + addressId, Address.class).getSingleResult();
				
			} catch (NoResultException e) {
				return null;
			}
			finally{
				userTransaction.commit();
			}
		

	}
	
	
}
